java数据结构与算法之两数之和于三数之和问题
Posted wen-pan
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了java数据结构与算法之两数之和于三数之和问题相关的知识,希望对你有一定的参考价值。
- 这种两数之和 与 三数之和的问题在面试中很常见,一般都作为第一道算法来考,如果连这个算法都写不出来,那么后面的面试基本上不会有好结果了!!!
①、题目描述
- 给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
- 你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
- 你可以按任意顺序返回答案。
②、力扣相关题目
③、解题
1、暴力解法
- 暴力解法最为简单,也最容易想到,但是时间复杂度为O(n^2)
/**
* 双重循环法
*/
public static int[] f1(int[] nums, int target)
int len = nums.length;
// 直接暴力循环
for (int i = 0; i < len; i++)
for (int j = i + 1; j < len; j++)
if (nums[j] + nums[i] == target)
return new int[]i, j;
return new int[0];
2、【排序 + 双指针】解法
- 双指针解法的时间复杂度取决于【排序的时间复杂度】,双指针的时间复杂度只有O(N)
/**
* 排序 + 双指针解法,时间复杂度取决于排序的时间复杂度,双指针的时间复杂度只有O(N)
*/
public static int[] f2(int[] nums, int target)
// 先将数组排升序
Arrays.sort(nums);
int p1 = 0;
int p2 = nums.length - 1;
// 使用双指针遍历数组
while (p1 < p2)
int temp = nums[p1] + nums[p2];
if (temp == target)
return new int[]p1, p2;
else if (temp > target)
p2--;
else
p1++;
return new int[0];
3、【妙用hash表】解法
- 使用hash表,以空间换时间的做法来降低时间复杂度为O(N)
/**
* hash表解法,时间复杂度O(N),空间复杂度O(N)
*/
public static int[] f3(int[] nums, int target)
// key为数值,value为该值对应的索引
HashMap<Integer, Integer> map = new HashMap<>();
for (int i = 0; i < nums.length; i++)
// 检查hash表中是否存在target - nums[i]的值,如果存在则说明有符合条件的两个数
Integer position = map.get(target - nums[i]);
if (position != null)
return new int[]position, i;
else
map.put(nums[i], i);
return new int[0];
④、三数之和问题
给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出数组中是否存在和为目标值 target 的那 三个 整数,如果是,则返回true,反之则返回false
- 明白了两数之和问题,那么三数之和问题就非常简单了,其实三数之和问题就是对于两数之和问题的一个扩展。
public static boolean f4(int[] nums, int target)
int len = nums.length;
// 对于每一个i位置都看看有没有其他任意两个位置(p1、p2)满足 nums[p1] + nums[p1] = target - nums[i]
// 也就是将三数之和转换为两数之和的问题
for (int i = 0; i < len; i++)
HashSet<Integer> set = new HashSet<>();
// 求两数之和有没有等于newTarget的
int newTarget = target - nums[i];
for (int j = i + 1; j < len; j++)
// set中是否存在一个数x,使得 x + nums[j] == newTarget
boolean contains = set.contains(newTarget - nums[j]);
// 找到了
if (contains)
return true;
else
// 没找到,则将当前数字加入set中
set.add(nums[j]);
return false;
以上是关于java数据结构与算法之两数之和于三数之和问题的主要内容,如果未能解决你的问题,请参考以下文章